    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------
    028     * PlotOrientation.java
    029     * --------------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 02-May-2003 : Version 1 (DG);
    038     * 17-Jul-2003 : Added readResolve() method (DG);
    039     * 21-Nov-2007 : Implemented hashCode() (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.plot;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Used to indicate the orientation (horizontal or vertical) of a 2D plot.
    050     */
    051    public final class PlotOrientation implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = -2508771828190337782L;
    055
    056        /** For a plot where the range axis is horizontal. */
    057        public static final PlotOrientation HORIZONTAL
    058                = new PlotOrientation("PlotOrientation.HORIZONTAL");
    059
    060        /** For a plot where the range axis is vertical. */
    061        public static final PlotOrientation VERTICAL
    062                = new PlotOrientation("PlotOrientation.VERTICAL");
    063
    064        /** The name. */
    065        private String name;
    066
    067        /**
    068         * Private constructor.
    069         *
    070         * @param name  the name.
    071         */
    072        private PlotOrientation(String name) {
    073            this.name = name;
    074        }
    075
    076        /**
    077         * Returns a string representing the object.
    078         *
    079         * @return The string.
    080         */
    081        public String toString() {
    082            return this.name;
    083        }
    084
    085        /**
    086         * Returns <code>true</code> if this object is equal to the specified
    087         * object, and <code>false</code> otherwise.
    088         *
    089         * @param obj  the object (<code>null</code> permitted).
    090         *
    091         * @return A boolean.
    092         */
    093        public boolean equals(Object obj) {
    094            if (this == obj) {
    095                return true;
    096            }
    097            if (!(obj instanceof PlotOrientation)) {
    098                return false;
    099            }
    100            PlotOrientation orientation = (PlotOrientation) obj;
    101            if (!this.name.equals(orientation.toString())) {
    102                return false;
    103            }
    104            return true;
    105        }
    106
    107        /**
    108         * Returns a hash code for this instance.
    109         *
    110         * @return A hash code.
    111         */
    112        public int hashCode() {
    113            return this.name.hashCode();
    114        }
    115
    116        /**
    117         * Ensures that serialization returns the unique instances.
    118         *
    119         * @return The object.
    120         *
    121         * @throws ObjectStreamException if there is a problem.
    122         */
    123        private Object readResolve() throws ObjectStreamException {
    124            Object result = null;
    125            if (this.equals(PlotOrientation.HORIZONTAL)) {
    126                result = PlotOrientation.HORIZONTAL;
    127            }
    128            else if (this.equals(PlotOrientation.VERTICAL)) {
    129                result = PlotOrientation.VERTICAL;
    130            }
    131            return result;
    132        }
    133
    134    }